﻿Public Class frm_transaction
    Private Sub First_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) _
    Handles MyBase.Load, TabControl1.Click
        Try
            check_due.Start()
            'for autocomplete
            sql = "SELECT accessionNumber FROM replica_items"
            auto_sugest(sql, txtAccesionNumBorrow)
            sql = "SELECT borrower_id FROM borrowers"
            auto_sugest(sql, cboBorrowerId)
            sql = "SELECT borrower_id FROM borrowers"
            ' auto_sugest(sql, cboRborrowerId)
            'for  the title of the books
            sql = "SELECT item_title FROM items"
            auto_sugest(sql, cboTitle)
            cboPurpose.Text = "Research"
            'for borrowers id
            'sql = "SELECT borrower_id FROM borrowers"
            'fillCombo(sql, cboBorrowerId, "borrower_id")
            'For retrieving the record in the datagridview of Borrowed Books
            sql = "SELECT  distinct(borrow_id),concat(`fname`,' ' ,`lname` , ' ' , `mname`) as 'NameOfBorrower' ," _
                                & "yr as 'Year/Sec', `item_title` as 'TitleOfBooks',`item_author` as 'Author'," _
                                & "bar.no_copy as 'No.OfCopies',purpose as 'Purpose',bar.dateBorrow as 'DateBorrowed',duedate AS 'DueDate'" _
                                & " FROM `items` i ,borrow bar,borrowers b" _
                                & " WHERE i.accessionNumber = bar.accessionNumber and bar.borrowers_id=b.borrower_id "
            fillGrid(sql, dtg_BlistOfBooks)


            'For retrieving the record in the datagridview to be returned books
            sql = "SELECT distinct(borrow_id),borrower_id, concat(`fname`,' ' ,`lname` , ' ' , `mname`) as 'NameOfBorrower' ," _
                                & "yr as 'Year/Sec', `item_title` as 'TitleOfBooks',`item_author` as 'Author'," _
                                & "bar.no_copy as 'No.OfCopies',purpose as 'Purpose', dateBorrow as 'DateBorrowed',duedate AS 'DueDate'" _
                                & " FROM `items` i ,borrow bar,borrowers b " _
                                & " WHERE i.accessionNumber = bar.accessionNumber and bar.borrowers_id=b.borrower_id" _
                                & " and borrowed = true AND status NOT IN ('Due')"
            fillGrid(sql, dtg_RlistReturn)
            clearGroupTxt(GroupBox1)
            clearGroupTxt(grp_Bgroup)
            dtg_RlistReturn.Columns(1).Visible = False
            dtg_RlistReturn.Columns(0).Visible = False
            dtg_BlistOfBooks.Columns(0).Visible = False
            cboBorrowerId.Text = ""
        Catch ex As Exception

        End Try
     
    End Sub
    Private Sub Search_BorrowedBooks(ByVal sender As System.Object, ByVal e As System.EventArgs) _
    Handles txt_Search.TextChanged
        Try
            sql = "SELECT distinct(borrow_id), concat(`fname`,' ' ,`lname` , ' ' , `mname`) as 'NameOfBorrower' ," _
             & "yr as 'Year/Sec', `item_title` as 'TitleofBooks',`item_author` as 'Author'," _
             & "bar.no_copy as 'No.OfCopies',purpose as 'Purpose',bar.dateBorrow as 'DateBorrowed',duedate AS 'DueDate'" _
             & " FROM `items` i ,borrow bar,borrowers b " _
             & " WHERE i.accessionNumber = bar.accessionNumber and bar.borrowers_id=b.borrower_id " _
             & " AND (i.accessionNumber LIKE '%" & txt_Search.Text & "%' OR item_title LIKE '%" & txt_Search.Text _
             & "%' OR item_author LIKE '%" & txt_Search.Text & "%' OR fname LIKE '%" & txt_Search.Text _
             & "%' OR lname LIKE '%" & txt_Search.Text & "%')"
            fillGrid(sql, dtg_BlistOfBooks)

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub


    Private Sub SaveReturn(ByVal sender As System.Object, ByVal e As System.EventArgs) _
    Handles btn_Rsave.Click
        Try
            If txtRname.Text = "" Then
                MsgBox("There is no borrower in the fields.", MsgBoxStyle.Exclamation)
            ElseIf Val(txtRRqty.Text) < Val(txtRCopyBorrowed.Text) Then
                MsgBox("The return quantity is less than the number of the books that you had borrow.", MsgBoxStyle.Exclamation)
            ElseIf Val(txtRRqty.Text) > Val(txtRCopyBorrowed.Text) Then
                MsgBox("The return quantity is greater than the number of the books that you had borrow.", MsgBoxStyle.Exclamation)
            Else

                sql = " INSERT INTO `return`(`accessionNumber`, `borrower_id`, `dateReturned`, `noCopy`,returned)" _
                        & " Values('" & AccessionNumber & "','" & cboRborrowerId.Text & "',NOW(),'" _
                        & txtRRqty.Text & "',true)"
                messageTrue = "Books returned."
                messageFalse = "Failed to return the books"
                CreateUpdateDeleteAllMessage(sql, messageTrue, messageFalse)
                'for the items
                edit("UPDATE replica_items set copy = copy + '" _
                                 & txtRRqty.Text & "' WHERE accessionNumber = '" & AccessionNumber & "'")
                'for the borrow
                edit("UPDATE borrow set borrowed = false WHERE borrow_id='" & Borrow_id & "'")
                'edit("UPDATE borrow set remarks = 'Returned' WHERE borrow_id='" & Borrow_id & "'")
                'to clear the text of the groupbox in return feiled.
                clearGroupTxt(grp_Rgroup)
                cboRborrowerId.Text = ""
                'call fisr load to refresh the record
                Call First_Load(sender, e)

            End If


        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub


    Private Sub btn_Bsave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Bsave.Click
        Try
            '  check_due.Stop()
            If txtName.Text = "" Or txtAuthor.Text = "" Or txtNumBorCopies.Text = "" Then
                MsgBox("You must fill up all the empty fields inorder to borrow.", MsgBoxStyle.Exclamation)
            Else

                If Val(txtNumCopies.Text) < Val(txtNumBorCopies.Text) Then
                    MsgBox("The borrowed quantity is greater than the number of the books in the library.", MsgBoxStyle.Exclamation)
                ElseIf txtNumCopies.Text = "Out of stuck" Then
                    MsgBox("The borrowed quantity is out of stuck.", MsgBoxStyle.Exclamation)
                ElseIf Val(txtNumBorCopies.Text) <= 0 Then
                    MsgBox("The borrowed quantity is 0, Its not valid.", MsgBoxStyle.Exclamation)
                Else

                    Dim formatdate As Date
                    If cboPurpose.Text = "Photocopy" Then
                        formatdate = DateAdd(DateInterval.Minute, 30, Now)
                        txtdue.Text = Format(formatdate, "yyyy-MM-dd HH:mm:ss")
                    ElseIf cboPurpose.Text = "Research" Then

                        If Format(Now, "tt") = "AM" Then
                            txtdue.Text = Format(Date.Now().Date, "yyyy-MM-dd") & " 11:30:00"
                        ElseIf Format(Now, "tt") = "PM" Then
                            txtdue.Text = Format(Date.Now().Date, "yyyy-MM-dd") & " 17:30:00"
                        End If

                    ElseIf cboPurpose.Text = "Overnight" Then
                        formatdate = DateAdd(DateInterval.Hour, 24, Now)
                        txtdue.Text = Format(formatdate, "yyyy-MM-dd HH:mm:ss")
                    End If

                    sql = "INSERT INTO borrow " _
                       & "(`borrowers_id`,`accessionNumber`,`no_copy`, `dateBorrow`,`user_id`,borrowed,purpose,duedate ) " _
                       & "VALUES " _
                       & "('" & cboBorrowerId.Text & "','" & txtAccesionNumBorrow.Text & "','" & txtNumBorCopies.Text _
                       & "',NOW(),'" & lbl_UserId.Text & "',true,'" & cboPurpose.Text & "','" & txtdue.Text & "')"
                    messageFalse = "Data failed to save."
                    messageTrue = "The data has been save."

                    CreateUpdateDeleteAllMessage(sql, messageTrue, messageFalse)

                    'updates the items copy
                    edit("UPDATE replica_items set copy = copy - '" _
                        & txtNumBorCopies.Text & "' Where accessionNumber='" & txtAccesionNumBorrow.Text & "'")

                    edit("UPDATE borrowers set statistic = statistic + 1  Where borrower_id='" _
                         & cboBorrowerId.Text & "'")

                    edit("UPDATE replica_items set statistic = statistic + 1  Where accessionNumber='" _
                        & txtAccesionNumBorrow.Text & "'")

                    'call fisr load to refresh the record
                    Call First_Load(sender, e)
                    cboBorrowerId.Text = ""
                    txtAccesionNumBorrow.Clear()
                    ' check_due.Start()
                End If
            End If

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

  
    Private Sub txtAccesionNumBorrow_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtAccesionNumBorrow.TextChanged
        Try
            If IsNumeric(txtAccesionNumBorrow.Text) Then

                sql = "SELECT distinct(replicaId), `item_title` ,`item_author` ," _
                       & " `copyright_yr`,copy " _
                       & " FROM `items`  i,  `replica_items` r " _
                       & "WHERE  i.`accessionNumber` = r.`accessionNumber` " _
                       & " AND  i.accessionNumber = '" & txtAccesionNumBorrow.Text & "'"
                fillSpecifictxt(sql)

                If dt.Rows.Count > 0 Then
                
                    cboTitle.Text = dt.Rows(0).Item("item_title")
                    txtAuthor.Text = dt.Rows(0).Item("item_author")
                    txtCopyrightYear.Text = dt.Rows(0).Item("copyright_yr")
                    If dt.Rows(0).Item("copy") <= 0 Then
                        txtNumCopies.Text = "Out of stuck"
                    Else
                        txtNumCopies.Text = dt.Rows(0).Item("copy")
                    End If



                Else

                    txtAuthor.Clear()
                    txtCopyrightYear.Clear()
                    txtNumCopies.Clear()
                    cboTitle.Text = ""
                End If
            Else
                txtAccesionNumBorrow.Clear()
            End If

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
     

    Private Sub cboBorrowerId_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboBorrowerId.TextChanged
        If IsNumeric(cboBorrowerId.Text) Then
            sql = "SELECT  `fname` ,`lname`, `yr`, `type`" _
            & " FROM `borrowers` WHERE `borrower_id` = '" & cboBorrowerId.Text & "'"
            fillSpecifictxt(sql)
            Try
                If dt.Rows.Count > 0 Then
                    txtName.Text = dt.Rows(0).Item("fname") & " " & dt.Rows(0).Item("lname")
                    txtyearSec.Text = dt.Rows(0).Item("yr")
                    txtType.Text = dt.Rows(0).Item("type")
                Else
                    clearGroupTxt(grp_Bgroup)
                End If
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        Else
            cboBorrowerId.Text = ""
        End If
       
       
    End Sub

    Private Sub TabControl2_Selected(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TabControlEventArgs) Handles TabControl2.Selected
        'call fisr load to refresh the record
        Call First_Load(sender, e)
        cboBorrowerId.Text = ""
    End Sub

    Private Sub TabControl1_Selected(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TabControlEventArgs) Handles TabControl1.Selected
        'call fisr load to refresh the record
        Call First_Load(sender, e)
        clearGroupTxt(grp_Rgroup)
        cboBorrowerId.Text = ""
        sql = "SELECT distinct(return_id),r.accessionNumber, concat(`fname`,' ' ,`lname` , ' ' , `mname`) as 'NameOfBorrower' ," _
              & " type, `item_title`,`item_author`," _
              & "r.noCopy  ,dateReturned " _
              & " FROM `items` i ,`return` r,`borrowers` b" _
              & " WHERE   i.accessionNumber = r.accessionNumber " _
              & "  and r.borrower_id=b.borrower_id  "
        fillGrid(sql, dtgListreturned)
        dtgListreturned.Columns(0).Visible = False
        '''''''''''''''''''

        'For retrieving the record in the datagridview to be returned books
        sql = "SELECT distinct(borrow_id), borrower_id, concat(`fname`,' ' ,`lname` , ' ' , `mname`) as 'NameOfBorrower' ," _
                            & "yr as 'Year/Sec', `item_title` as 'TitleOfBooks',`item_author` as 'Author'," _
                            & "bar.no_copy as 'No.OfCopies', dateBorrow as 'DateBorrowed',duedate AS 'DueDate' " _
                            & " FROM `items` i ,borrow bar,borrowers b " _
                            & " WHERE i.accessionNumber = bar.accessionNumber and bar.borrowers_id=b.borrower_id" _
                            & " and borrowed = true AND status='Due'"
        fillGrid(sql, dtgPenalties)
        dtgPenalties.Columns(0).Visible = False
        dtgPenalties.Columns(1).Visible = False
        clearGroupTxt(grp_Rgroup)
    End Sub
    Public AccessionNumber As Integer
    Public Borrow_id As Integer
   
 
 
    Private Sub cboTitle_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboTitle.TextChanged
        sql = "SELECT distinct(replicaId),r.accessionNumber, `item_title` ,`item_author` ," _
              & " `copyright_yr`,copy " _
              & " FROM `items` i ,replica_items r" _
              & " WHERE i.accessionNumber = r.accessionNumber " _
              & " AND  i.item_title = '" & cboTitle.Text & "'"
        fillSpecifictxt(sql)
        Try
            If dt.Rows.Count > 0 Then
                txtAccesionNumBorrow.Text = dt.Rows(0).Item("accessionNumber")
                cboTitle.Text = dt.Rows(0).Item("item_title")
                'txtAuthor.Text = dt.Rows(0).Item("item_author")
                txtCopyrightYear.Text = dt.Rows(0).Item("copyright_yr")
                txtNumCopies.Text = dt.Rows(0).Item("copy")

            Else
                txtAccesionNumBorrow.Clear()
                txtCopyrightYear.Clear()
                txtNumCopies.Clear()
            End If
        Catch ex As Exception
            MsgBox(ex.Message & " cboTitle_TextChanged")
        End Try

    End Sub

    Private Sub TabControl3_Selected(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TabControlEventArgs) Handles TabControl3.Selected
        Try
            sql = "SELECT distinct(return_id),r.accessionNumber, concat(`fname`,' ' ,`lname` , ' ' , `mname`) as 'NameOfBorrower' ," _
                          & " type, `item_title`,`item_author`," _
                          & "r.noCopy  ,dateReturned" _
                          & " FROM `items` i ,`return` r,`borrowers` b" _
                          & " WHERE   i.accessionNumber = r.accessionNumber " _
                          & "  and r.borrower_id=b.borrower_id  "
            fillGrid(sql, dtgListreturned)
            dtgListreturned.Columns(0).Visible = False
            '''''''''''''''''''

            'For retrieving the record in the datagridview to be returned books
            sql = "SELECT distinct(borrow_id), borrower_id, concat(`fname`,' ' ,`lname` , ' ' , `mname`) as 'NameOfBorrower' ," _
                                & "yr as 'Year/Sec', `item_title` as 'TitleOfBooks',`item_author` as 'Author'," _
                                & "bar.no_copy as 'No.OfCopies', dateBorrow as 'DateBorrowed' " _
                                & " FROM `items` i ,borrow bar,borrowers b " _
                                & " WHERE i.accessionNumber = bar.accessionNumber and bar.borrowers_id=b.borrower_id" _
                                & " and borrowed = true AND status='Due'"
            fillGrid(sql, dtgPenalties)

            'call fisr load to refresh the record
            Call First_Load(sender, e)
            clearGroupTxt(grp_Rgroup)
            cboBorrowerId.Text = ""
            sql = "SELECT distinct(return_id),r.accessionNumber, concat(`fname`,' ' ,`lname` , ' ' , `mname`) as 'NameOfBorrower' ," _
                  & " type, `item_title`,`item_author`," _
                  & "r.noCopy  ,dateReturned" _
                  & " FROM `items` i ,`return` r,`borrowers` b" _
                  & " WHERE   i.accessionNumber = r.accessionNumber " _
                  & "  and r.borrower_id=b.borrower_id  "
            fillGrid(sql, dtgListreturned)
            dtgListreturned.Columns(0).Visible = False
            '''''''''''''''''''
 
            clearGroupTxt(grp_Rgroup)
            'dtgPenalties.Columns(0).Visible = False
            'dtgPenalties.Columns(1).Visible = False

            txtamount.Text = ""
            txtminutes.Text = ""
            txttenderedAmount.Text = ""
            txtOverdueTime.Text = ""
        Catch ex As Exception
            ' MsgBox(ex.Message)
        End Try
       
    End Sub

    Private Sub check_due_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles check_due.Tick
        
        sql = "SELECT MINUTE(TIMEDIFF(Now(),dateBorrow)),borrow_id FROM borrow where borrowed=true AND purpose = 'Photocopy' "
        checkOverduePurposed(sql, "Photocopy")
        sql = "SELECT dateBorrow,borrow_id FROM borrow where borrowed=true AND purpose = 'Research'"
        checkOverduePurposed(sql, "Research")
        sql = "SELECT HOUR( TIMEDIFF( NOW( ) ,  `dateBorrow` ) ) AS  'time',`borrow_id` FROM   `borrow` where borrowed=true AND purpose = 'Overnight'"
        checkOverduePurposed(sql, "Overnight")
       
    End Sub
  
  

    Private Sub txtrbooksSearch_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtrbooksSearch.TextChanged
        sql = "SELECT distinct(return_id),r.accessionNumber, concat(`fname`,' ' ,`lname` , ' ' , `mname`) as 'NameOfBorrower' ," _
              & " type, `item_title`,`item_author`," _
              & "r.noCopy  ,dateReturned" _
              & " FROM `items` i ,`return` r,`borrowers` b" _
              & " WHERE   i.accessionNumber = r.accessionNumber " _
              & "  and r.borrower_id=b.borrower_id  " _
              & "AND ( r.accessionNumber like '%" & txtrbooksSearch.Text & "%'" _
              & " OR fname like '%" & txtrbooksSearch.Text & "%'" _
              & " OR lname like '%" & txtrbooksSearch.Text & "%')"
        fillGrid(sql, dtgListreturned)
    End Sub
  

    Private Sub txtamount_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtamount.TextChanged
        Try
            If txtamount.Text = "" Then
                txtTotPay.Text = ""
            Else
                If IsNumeric(txtamount.Text) Then
                    formulaofpayments(Me)
                Else
                    txtamount.Clear()
                End If

            End If
        Catch ex As Exception
            '  MsgBox(ex.Message)
        End Try

    End Sub

    Private Sub txtminutes_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtminutes.TextChanged
        Try
            If txtminutes.Text = "" Then
                txtTotPay.Text = ""
            Else
                If IsNumeric(txtminutes.Text) Then
                    formulaofpayments(Me)
                Else
                    txtminutes.Clear()
                End If

            End If
        Catch ex As Exception
            ' MsgBox(ex.Message)
        End Try

    End Sub

    Private Sub txttenderedAmount_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txttenderedAmount.TextChanged
        Try

            If txttenderedAmount.Text = "" Then
                txtChange.Text = ""
            Else
                If IsNumeric(txttenderedAmount.Text) Then
                    txtChange.Text = Val(txttenderedAmount.Text) - Val(txtTotPay.Text)
                Else
                    txttenderedAmount.Clear()
                End If

            End If
        Catch ex As Exception
            MsgBox(ex.Message & " txttenderedAmount_TextChanged")
        End Try
    End Sub

    Private Sub btnPSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPSave.Click
        Try
            If txtamount.Text = "" Or txtminutes.Text = "" Or txttenderedAmount.Text = "" Or txtOverdueTime.Text = "" Then
                MsgBox("You must fill all the fields inorder to save.", MsgBoxStyle.Exclamation)
            ElseIf Val(txtChange.Text) < 0 Then
                MsgBox("The tendered amount is less than the total payments. Its not valid.", MsgBoxStyle.Exclamation)
            Else
                'save to penalties
                sql = "INSERT INTO `penalties` (`datePay`, `accessionNumber`, `payments`, `status`, `borrower_id`,`borrow_id`)" _
                & " VALUES (Now(),'" & AccessionNumber & "','" & txtTotPay.Text & "','Settled','" _
                & dtgPenalties.CurrentRow.Cells(1).Value & "','" & dtgPenalties.CurrentRow.Cells(0).Value & "')"
                messageTrue = "Payment saved."
                messageFalse = "Error to save. Contact administrator."
                CreateUpdateDeleteAllMessage(sql, messageTrue, messageFalse)
                ''''''
                'save to return
                sql = " INSERT INTO `return`(`accessionNumber`, `borrower_id`, `dateReturned`, `noCopy`,returned)" _
                                & " Values('" & AccessionNumber & "','" & dtgPenalties.CurrentRow.Cells(1).Value _
                                & "',NOW(),'" & dtgPenalties.CurrentRow.Cells(6).Value & "',true)"
                create(sql)
                'for the items
                edit("UPDATE replica_items set copy = copy + '" _
                                 & dtgPenalties.CurrentRow.Cells(5).Value _
                                 & "' WHERE accessionNumber = '" & AccessionNumber & "'")
                'for the borrow
                edit("UPDATE borrow set borrowed = false WHERE borrow_id='" & dtgPenalties.CurrentRow.Cells(0).Value & "'")
                'call the first load


                'call fisr load to refresh the record
                Call First_Load(sender, e)
                clearGroupTxt(grp_Rgroup)
                cboBorrowerId.Text = ""
                sql = "SELECT distinct(return_id),r.accessionNumber, concat(`fname`,' ' ,`lname` , ' ' , `mname`) as 'NameOfBorrower' ," _
                      & " type, `item_title`,`item_author`," _
                      & "r.noCopy  ,dateReturned" _
                      & " FROM `items` i ,`return` r,`borrowers` b" _
                      & " WHERE   i.accessionNumber = r.accessionNumber " _
                      & "  and r.borrower_id=b.borrower_id  "
                fillGrid(sql, dtgListreturned)
                dtgListreturned.Columns(0).Visible = False
                '''''''''''''''''''

                'For retrieving the record in the datagridview to be returned books
                sql = "SELECT distinct(borrow_id), borrower_id, concat(`fname`,' ' ,`lname` , ' ' , `mname`) as 'NameOfBorrower' ," _
                                    & "yr as 'Year/Sec', `item_title` as 'TitleOfBooks',`item_author` as 'Author'," _
                                    & "bar.no_copy as 'No.OfCopies', dateBorrow as 'DateBorrowed' " _
                                    & " FROM `items` i ,borrow bar,borrowers b " _
                                    & " WHERE i.accessionNumber = bar.accessionNumber and bar.borrowers_id=b.borrower_id" _
                                    & " and borrowed = true AND status='Due'"
                fillGrid(sql, dtgPenalties)
                dtgPenalties.Columns(0).Visible = False
                dtgPenalties.Columns(1).Visible = False
                clearGroupTxt(grp_Rgroup)

                clearGroupTxt(GroupBox7)
                clearGroupTxt(GroupBox10)
            End If

            'Call TabControl1_Selected(sender, e)
            'Call TabControl2_Selected(sender, e)

        Catch ex As Exception
            MsgBox(ex.Message & " btnPSave_Click")
        End Try
    End Sub

    Private Sub txtSearchPborrower_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSearchPborrower.TextChanged
        Try
            'For retrieving the record in the datagridview to be returned books
            sql = "SELECT distinct(borrow_id), borrower_id, concat(`fname`,' ' ,`lname` , ' ' , `mname`) as 'NameOfBorrower' ," _
                & "yr as 'Year/Sec', `item_title` as 'TitleOfBooks',`item_author` as 'Author'," _
                & "bar.no_copy as 'No.OfCopies', dateBorrow as 'DateBorrowed' " _
                & " FROM `items` i ,borrow bar,borrowers b " _
                & " WHERE i.accessionNumber = bar.accessionNumber and bar.borrowers_id=b.borrower_id" _
                & " and borrowed = true AND status='Due' AND borrower_id Like '%" & txtSearchPborrower.Text & "%'"
            fillGrid(sql, dtgPenalties)
            'dtgPenalties.Columns(0).Visible = False
            'dtgPenalties.Columns(1).Visible = False
        Catch ex As Exception
            MsgBox(ex.Message & " txtSearchPborrower_TextChanged")
        End Try
    End Sub

    Private Sub dtg_RlistReturn_CellClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dtg_RlistReturn.CellClick

    End Sub

   

    Private Sub btnSearchAccesion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearchAccesion.Click
        Try
            check_due.Stop()
            sql = "SELECT i.item_id,i.`accessionNumber` AS 'Accession#', `item_title` AS 'Title'" _
                & ", `item_author` AS 'Author',`item_publisher` AS 'Publisher', `copyright_yr` AS 'Copyright Year' " _
                & ", `copy` as 'Quantity', " _
                & "`item_cost` AS 'Cost'," _
                & "case when copy=0 then 'Not available' else 'Available' end as 'Status' " _
                & ",r.statistic as 'Count of Borrowed' FROM `items`  i,  `replica_items` r " _
                & "WHERE  i.`accessionNumber` = r.`accessionNumber` and i.item_id=r.item_id"
            fillGrid(sql, frm_list.dtgListBooks)
            frm_list.dtgListBooks.Columns(0).Visible = False
            frm_list.Show()
            frm_list.Focus()

            frm_list.TabControl1.Controls.Remove(frm_list.TabPage2)
            check_due.Start()
        Catch ex As Exception
            MsgBox(ex.Message & " txt_Search_TextChanged", MsgBoxStyle.Exclamation)
        End Try
    End Sub

    Private Sub btnSearchBorrower_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearchBorrower.Click
        check_due.Stop()
        fillGrid("SELECT `borrower_id` as 'Id', concat(`lname` , ', ' ,`fname`) as 'Name'," _
                 & "address as 'Address',sex as 'Gender' FROM borrowers", frm_list.dtgListBorrower)
        frm_list.Show()
        frm_list.Focus()
        frm_list.TabControl1.Controls.Remove(frm_list.TabPage1)
        check_due.Start()
    End Sub
 
 
    Private Sub dtg_RlistReturn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dtg_RlistReturn.Click
        Try
            cboRborrowerId.Text = dtg_RlistReturn.CurrentRow.Cells(1).Value
        Catch ex As Exception

        End Try

    End Sub

    Private Sub cboRborrowerId_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboRborrowerId.TextChanged
        Try
            sql = "SELECT distinct(borrow_id),bar.accessionNumber, concat(`fname`,' ' ,`lname` , ' ' , `mname`) as 'NameOfBorrower' ," _
                & " type, `item_title`,`item_author`," _
                & "bar.no_copy ,copyright_yr" _
                & " FROM `items` i ,borrow bar,borrowers b" _
                & " WHERE   i.accessionNumber = bar.accessionNumber " _
                & " and borrowed = true and bar.borrowers_id=b.borrower_id " _
                & " AND bar.borrowers_id = '" & cboRborrowerId.Text & "'"
            fillSpecifictxt(sql)
            If dt.Rows.Count > 0 Then
                Borrow_id = dt.Rows(0).Item("borrow_id")
                'MsgBox(Borrow_id)
                AccessionNumber = dt.Rows(0).Item("accessionNumber")
                txtRname.Text = dt.Rows(0).Item("NameOfBorrower")
                cboRbookTitle.Text = dt.Rows(0).Item("item_title")
                txtRauthor.Text = dt.Rows(0).Item("item_author")
                txtRcopyRightYr.Text = dt.Rows(0).Item("copyright_yr")
                txtRCopyBorrowed.Text = dt.Rows(0).Item("no_copy")

            Else

            End If

        Catch ex As Exception
            MsgBox(ex.Message & " cboRborrowerId_TextChanged")
        End Try
    End Sub
    Private Sub dtgPenalties_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles dtgPenalties.Click
        Try
            sql = "SELECT  TIMEDIFF( NOW( ) ,  `duedate` ),`accessionNumber` " _
              & "FROM  `borrow` WHERE `borrow_id` = '" & dtgPenalties.CurrentRow.Cells(0).Value.ToString & "'"
            fillSpecifictxt(sql)
            If dt.Rows.Count > 0 Then
                txtOverdueTime.Text = dt.Rows(0).Item(0).ToString
                AccessionNumber = dt.Rows(0).Item(1).ToString
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
       
    End Sub
 
    Private Sub txtNumBorCopies_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtNumBorCopies.TextChanged
        Try
            If Not IsNumeric(txtNumBorCopies.Text) Then
                txtNumBorCopies.Clear()
            End If
        Catch ex As Exception

        End Try

    End Sub

   
    

    Private Sub txtRRqty_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtRRqty.TextChanged
        Try
            If IsNumeric(txtRRqty.Text) Then
            Else
                txtRRqty.Clear()
            End If
        Catch ex As Exception

        End Try
    End Sub
End Class