﻿Imports MySql.Data.MySqlClient
Module selects
    Public con As MySqlConnection = strConnection()
    Dim cmd As New MySqlCommand
    Dim da As New MySqlDataAdapter
    Public dt As New DataTable
    Public ds As New DataSet
    Public sql As String
    Public Sub save_or_update(ByVal sql As String, ByVal add As String, ByVal edit As String)
        con.Open()
        With cmd
            .Connection = con
            .CommandText = sql
        End With
        dt = New DataTable
        da = New MySqlDataAdapter(sql, con)
        da.Fill(dt)
        con.Close()
        If dt.Rows.Count > 0 Then
            con.Open()
            With cmd
                .Connection = con
                .CommandText = edit
                cmd.ExecuteNonQuery()

            End With
            con.Close()
        Else
            con.Open()
            With cmd
                .Connection = con
                .CommandText = add
                cmd.ExecuteNonQuery()

            End With
        End If
        con.Close()
    End Sub

    Public Sub select_navigation(ByVal sql As String)

        Try
            con.Open()
            With cmd
                .Connection = con
                .CommandText = sql
            End With
            da = New MySqlDataAdapter(sql, con)
            dt = New DataTable
            da.Fill(dt)
            da.Dispose()
            con.Close()
        Catch ex As Exception
            MsgBox(ex.Message & " select_navigation procedures in the selects modules.", MsgBoxStyle.Information)
        End Try

    End Sub
    Public Sub fillCombo(ByVal sql As String, ByVal cbo As ComboBox, ByVal value As String)

        Try
            con.Open()
            With cmd
                .Connection = con
                .CommandText = sql
            End With
            da.SelectCommand = cmd
            ' da = New MySqlDataAdapter(sql, con)
            dt = New DataTable
            'da.Fill(ds, "enrollmentdb")
            da.Fill(dt)
            With cbo
                '.DataSource = ds.Tables(0)
                .DataSource = dt

                .ValueMember = value
                .DisplayMember = value
            End With
            da.Dispose()
            con.Close()

        Catch ex As Exception
            MsgBox(ex.Message & " fillCombo procedures in the selects modules.", MsgBoxStyle.Information)
        End Try

    End Sub
    Public Sub fillListView(ByVal sql As String, ByVal lst As ListView)

        Try
            con.Open()
            lst.Items.Clear()
            With cmd
                .Connection = con
                .CommandText = sql
            End With
            da = New MySqlDataAdapter(sql, con)
            dt = New DataTable
            da.Fill(dt)

            For Each row As DataRow In dt.Rows
                With lst.Items.Add(row.Item(0))
                    .subitems.add(row.Item(1))
                    .subitems.add(row.Item(2))
                    .subitems.add(row.Item(3))
                    .subitems.add(row.Item(4))
                    .subitems.add(row.Item(5))
                    .subitems.add(row.Item(6))
                    .subitems.add(row.Item(7))
                End With
            Next
            da.Dispose()
            con.Close()
        Catch ex As Exception
            MsgBox(ex.Message & " fillListView procedures in the selects modules.", MsgBoxStyle.Information)
        End Try

    End Sub
    Public Sub fillGrid(ByVal sql As String, ByVal dtg As DataGridView)

        Try
            con.Open()
            With cmd
                .Connection = con
                .CommandText = sql
            End With
            da = New MySqlDataAdapter(sql, con)
            dt = New DataTable
            da.Fill(dt)
            dtg.DataSource = dt
            da.Dispose()
            con.Close()
        Catch ex As Exception
            MsgBox(ex.Message & " fillGrid procedures in the selects modules.", MsgBoxStyle.Information)
        End Try

    End Sub
   
    Public Sub filltxtAuto(ByVal sql As String, ByVal txt As Object)

        Try
            con.Open()
            With cmd
                .Connection = con
                .CommandText = sql
            End With
            da = New MySqlDataAdapter(sql, con)
            dt = New DataTable
            da.Fill(dt)
            txt.Text = dt.Rows(0).Item(0)
            da.Dispose()
            con.Close()
        Catch ex As Exception
            MsgBox(ex.Message & " filltxtAuto procedures in the selects modules.", MsgBoxStyle.Information)
        End Try

    End Sub
    Public Sub fillSpecifictxt(ByVal sql As String)

        Try
            con.Open()
            With cmd
                .Connection = con
                .CommandText = sql
            End With
            da = New MySqlDataAdapter(sql, con)
            dt = New DataTable
            da.Fill(dt)
            da.Dispose()
            con.Close()
        Catch ex As Exception
            MsgBox(ex.Message & " fillSpecifictxt procedures in the selects modules.", MsgBoxStyle.Information)
        End Try
     
    End Sub
    Public Sub auto_sugest(ByVal sql As String, ByVal txt As Object)
        Try
            con.Open()
            With cmd
                .Connection = con
                .CommandText = sql
            End With
            dt = New DataTable
            da = New MySqlDataAdapter(sql, con)
            da.Fill(dt)
            Dim r As DataRow
            txt.AutoCompleteCustomSource.Clear()
            For Each r In dt.Rows
                txt.AutoCompleteCustomSource.Add(r.Item(0).ToString)
            Next
            da.Dispose()
            con.Close()

        Catch ex As Exception
            MsgBox(ex.Message & " auto_sugest in the select modules")
        End Try

    End Sub
#Region "Report"
    Public Sub reports(ByVal sql As String, ByVal rptname As String, ByVal crystalRpt As Object)
        Try
            con.Open()

            Dim reportname As String
            With cmd
                .Connection = con
                .CommandText = sql
            End With
            ds = New DataSet
            da = New MySqlDataAdapter(sql, con)
            da.Fill(ds)
            reportname = rptname
            Dim reportdoc As New CrystalDecisions.CrystalReports.Engine.ReportDocument
            Dim strReportPath As String
            strReportPath = Application.StartupPath & "\reports\" & reportname & ".rpt"
            With reportdoc
                .Load(strReportPath)
                .SetDataSource(ds.Tables(0))
            End With
            With crystalRpt
                .ShowRefreshButton = False
                .ShowCloseButton = False
                .ShowGroupTreeButton = False
                .ReportSource = reportdoc
            End With
        Catch ex As Exception
            MsgBox(ex.Message & "No Crystal Reports have been Installed")
        End Try
        con.Close()
        da.Dispose()
    End Sub
#End Region
End Module
