﻿Imports MySql.Data.MySqlClient
Module INVENTORY


    Public Sub allBooks(ByVal dtg As DataGridView)
        sql = "SELECT  distinct(i.`accessionNumber`) as 'Accession Number',i.`item_id`, `item_title` as 'Title', `item_author` as 'Author'," _
        & "`copyright_yr` AS 'Copyright Year', `copy` as 'Copy', `item_cost` AS 'Cost',statistic as 'Statistic' FROM `items`  i,  `replica_items` r " _
        & "WHERE  i.`accessionNumber` = r.`accessionNumber` AND i.item_id=r.item_id"
        fillGrid(sql, dtg)
        dtg.Columns(1).Visible = False
    End Sub
    'Public Sub searchBookReceive(ByVal dtg As DataGridView, ByVal strdate As Object, ByVal enddate As Object)
    '    sql = "SELECT  distinct(i.`accessionNumber`) as 'Accession Number',`item_id`, `item_title` as 'Title', `item_author` as 'Author'," _
    '   & "`copyright_yr` AS 'Copyright Year', `copy` as 'Copy', `item_cost` AS 'Cost' FROM `items`  i,  `replica_items` r " _
    '   & "WHERE  i.`accessionNumber` = r.`accessionNumber` " _
    '   & "AND date(datereceive)  BETWEEN '" & strdate.text & "' and '" & enddate.text & "'"""
    '    fillGrid(sql, dtg)
    '    dtg.Columns(1).Visible = False
    'End Sub
    Public Sub searchAllBooks(ByVal dtg As DataGridView, ByVal txt As TextBox)
        sql = "SELECT  distinct(i.`accessionNumber`) as 'Accession Number',i.`item_id`, `item_title` as 'Title', `item_author` as 'Author'," _
        & "`copyright_yr` AS 'Copyright Year', `copy` as 'Copy', `item_cost` AS 'Cost',statistic as 'Statistic' FROM `items`  i,  `replica_items` r " _
        & "WHERE  i.`accessionNumber` = r.`accessionNumber` AND i.item_id=r.item_id" _
         & " AND (i.`accessionNumber` LIKE '%" & txt.Text _
         & "%' OR item_title LIKE '%" & txt.Text & "%' OR item_author LIKE '%" & txt.Text & "%')"
        fillGrid(sql, dtg)
        dtg.Columns(1).Visible = False
    End Sub

    Public Sub allBorrowed(ByVal dtg As DataGridView)
        sql = "SELECT distinct(`borrow_id`),i.`accessionNumber`as 'Accession Number', `item_title` as 'Title', `item_author` as 'Author',`no_copy` AS 'Copy'," _
        & "`dateBorrow` AS 'DATE AND TIME', `purpose` AS 'Purpose' FROM `items`  i, `borrow` b WHERE  i.`accessionNumber`=b.`accessionNumber`"
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub searchAllBorrowed(ByVal dtg As DataGridView, ByVal txt As TextBox)
        sql = "SELECT  distinct(`borrow_id`),i.`accessionNumber`as 'Accession Number', `item_title` as 'Title', `item_author` as 'Author',`no_copy` AS 'Copy'," _
        & "`dateBorrow` AS 'DATE AND TIME', `purpose` AS 'Purpose' FROM `items`  i, `borrow` b WHERE  i.`accessionNumber`=b.`accessionNumber`" _
        & " AND  (i.`accessionNumber` LIKE '%" & txt.Text _
        & "%' OR item_title LIKE '%" & txt.Text & "%' OR item_author LIKE '%" & txt.Text & "%')"
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub searchBorrowdate(ByVal dtg As DataGridView, ByVal strdate As Object, ByVal enddate As Object)
        sql = "SELECT  distinct(`borrow_id`),i.`accessionNumber`as 'Accession Number', `item_title` as 'Title', `item_author` as 'Author',`no_copy` AS 'Copy'," _
       & "`dateBorrow` AS 'DATE AND TIME', `purpose` AS 'Purpose' FROM `items`  i, `borrow` b WHERE  i.`accessionNumber`=b.`accessionNumber`" _
       & " AND date(dateBorrow)  BETWEEN '" & strdate.text & "' and '" & enddate.text & "'"
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub allReturned(ByVal dtg As DataGridView)
        sql = "SELECT distinct(`return_id`), i.`accessionNumber`as 'Accession Number', " _
        & "`item_title` as 'Title', `item_author` as 'Author',r.`noCopy` AS 'Copy'," _
        & " r.`dateReturned` AS 'DATE AND TIME' FROM `items`  i, `return` r " _
        & " WHERE  i.`accessionNumber`=r.`accessionNumber` "
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub searchAllReturned(ByVal dtg As DataGridView, ByVal txt As TextBox)
        sql = "SELECT distinct(`return_id`), i.`accessionNumber`as 'Accession Number', " _
        & "`item_title` as 'Title', `item_author` as 'Author',r.`noCopy` AS 'Copy'," _
        & " r.`dateReturned` AS 'DATE AND TIME' FROM `items`  i, `return` r " _
        & " WHERE  i.`accessionNumber`=r.`accessionNumber`" _
         & " AND  (i.`accessionNumber` LIKE '%" & txt.Text _
        & "%' OR item_title LIKE '%" & txt.Text & "%' OR item_author LIKE '%" & txt.Text & "%')"
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub searchreturndate(ByVal dtg As DataGridView, ByVal strdate As Object, ByVal enddate As Object)
        sql = "SELECT distinct(`return_id`), i.`accessionNumber`as 'Accession Number', " _
           & "`item_title` as 'Title', `item_author` as 'Author',r.`noCopy` AS 'Copy'," _
           & " r.`dateReturned` AS 'DATE AND TIME' FROM `items`  i, `return` r " _
           & " WHERE  i.`accessionNumber`=r.`accessionNumber` " _
           & " AND date(dateReturned)  BETWEEN '" & strdate.text & "' and '" & enddate.text & "'"
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub Lost(ByVal dtg As DataGridView)
        sql = ""
        fillGrid(sql, dtg)
    End Sub
    Public Sub Replaced(ByVal dtg As DataGridView)
        sql = ""
        fillGrid(sql, dtg)
    End Sub
    Public Sub allborrowers(ByVal dtg As DataGridView)
        sql = "SELECT concat(`fname`,' ', `lname`) as 'Name' , `address` As 'Address', `age` as 'Age', `sex` as 'Gender', `type` as 'Type' FROM `borrowers` "
        fillGrid(sql, dtg)
    End Sub
    Public Sub allSearchborrowers(ByVal dtg As DataGridView, ByVal txt As Object)
        sql = "SELECT concat(`fname`,' ', `lname`) as 'Name' , `address` As 'Address'" _
        & ", `age` as 'Age', `sex` as 'Gender', `type` as 'Type',statistic as 'Statistic' FROM `borrowers` " _
        & " WHERE borrower_id like '%" & txt.text & "%'" _
        & " OR fname like '%" & txt.text & "%'" _
        & " OR lname like '%" & txt.text & "%'"
        fillGrid(sql, dtg)
    End Sub
   
    Public Sub AllOverdue(ByVal dtg As DataGridView)
        sql = "SELECT distinct(`borrow_id`), CONCAT (`fname`,' ', `lname`,' ', `mname`) as 'Full Name' ,`yr` as 'Year',i.`accessionNumber`as 'Accession Number', `item_title` as 'Title'," _
        & "`item_author` as 'Author',`no_copy` AS 'Copy', `dateBorrow` AS 'DATE AND TIME', `purpose` AS 'Purpose'" _
        & " FROM `items`  i, `borrow` b, borrowers bs" _
        & " WHERE  i.`accessionNumber`=b.`accessionNumber` AND bs.borrower_id=b.borrowers_id AND status = 'Due'"
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub searchAllOverdue(ByVal dtg As DataGridView, ByVal txt As TextBox)
        sql = "SELECT distinct(`borrow_id`), CONCAT (`fname`,' ', `lname`,' ', `mname`) as 'Full Name' ,`yr` as 'Year',i.`accessionNumber`as 'Accession Number', `item_title` as 'Title'," _
        & "`item_author` as 'Author',`no_copy` AS 'Copy', `dateBorrow` AS 'DATE AND TIME', `purpose` AS 'Purpose'" _
        & " FROM `items`  i, `borrow` b, borrowers bs" _
        & " WHERE  i.`accessionNumber`=b.`accessionNumber` AND bs.borrower_id=b.borrowers_id AND status = 'Due'" _
        & " AND (i.`accessionNumber` LIKE '%" & txt.Text & "%' " _
        & " OR item_title  LIKE '%" & txt.Text & "%' " _
        & " OR item_author  LIKE '%" & txt.Text & "%' " _
        & " OR fname  LIKE '%" & txt.Text & "%' " _
        & " OR lname  LIKE '%" & txt.Text & "%') "
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub searchOverdueddate(ByVal dtg As DataGridView, ByVal strdate As Object, ByVal enddate As Object)
        sql = "SELECT distinct(`borrow_id`), CONCAT (`fname`,' ', `lname`,' ', `mname`) as 'Full Name' ,`yr` as 'Year',i.`accessionNumber`as 'Accession Number', `item_title` as 'Title'," _
         & "`item_author` as 'Author',`no_copy` AS 'Copy', `dateBorrow` AS 'DATE AND TIME', `purpose` AS 'Purpose'" _
         & " FROM `items`  i, `borrow` b, borrowers bs" _
         & " WHERE  i.`accessionNumber`=b.`accessionNumber` AND bs.borrower_id=b.borrowers_id AND status = 'Due'" _
          & " AND date(dateBorrow) BETWEEN '" & strdate.text & "' and '" & enddate.text & "'"
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub AllSettled(ByVal dtg As DataGridView)
        sql = "SELECT distinct(`penalty_id`), CONCAT (`fname`,' ', `lname`,' ', `mname`) as 'Full Name' ,`yr` as 'Year'," _
        & "i.`accessionNumber`as 'Accession Number',`item_title` as 'TitleOfBooks', `item_author` as 'Author',payments AS 'Amount Paid',datePay as 'Date Settled'" _
        & " FROM `penalties` p, `borrowers` b,`items` i  " _
        & " WHERE  b.`borrower_id`=p.`borrower_id` AND p.`accessionNumber`=i.`accessionNumber` "
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub searchAllSettled(ByVal dtg As DataGridView, ByVal txt As TextBox)
        sql = "SELECT distinct(`penalty_id`), CONCAT (`fname`,' ', `lname`,' ', `mname`) as 'Full Name' ,`yr` as 'Year'," _
        & "i.`accessionNumber`as 'Accession Number',`item_title` as 'TitleOfBooks', `item_author` as 'Author',payments AS 'Amount Paid',datePay as 'Date Settled'" _
        & " FROM `penalties` p, `borrowers` b,`items` i  " _
        & " WHERE  b.`borrower_id`=p.`borrower_id` AND p.`accessionNumber`=i.`accessionNumber` " _
        & " AND (i.`accessionNumber` LIKE '%" & txt.Text & "%' " _
        & " OR item_title  LIKE '%" & txt.Text & "%' " _
        & " OR item_author  LIKE '%" & txt.Text & "%' " _
        & " OR fname  LIKE '%" & txt.Text & "%' " _
        & " OR lname  LIKE '%" & txt.Text & "%') "
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub searchSettleddate(ByVal dtg As DataGridView, ByVal strdate As Object, ByVal enddate As Object)
        sql = "SELECT distinct(`penalty_id`), CONCAT (`fname`,' ', `lname`,' ', `mname`) as 'Full Name' ,`yr` as 'Year'," _
         & "i.`accessionNumber`as 'Accession Number',`item_title` as 'TitleOfBooks', `item_author` as 'Author',payments AS 'Amount Paid',datePay as 'Date Settled'" _
         & " FROM `penalties` p, `borrowers` b,`items` i  " _
         & " WHERE  b.`borrower_id`=p.`borrower_id` AND p.`accessionNumber`=i.`accessionNumber` " _
         & " AND date(datePay) BETWEEN '" & strdate.text & "' and '" & enddate.text & "'"
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub Allpenalties(ByVal dtg As DataGridView)
        sql = "SELECT distinct(`borrow_id`), CONCAT (`fname`,' ', `lname`,' ', `mname`) as 'Full Name' " _
        & ",`yr` AS 'Year',i.`accessionNumber`as 'Accession Number',`item_title` AS 'TitleOfBooks', `item_author` AS 'Author',`dateBorrow` as 'DateBorrow'" _
        & " FROM `borrow` b,  `borrowers`  bs,`items` i  " _
        & " WHERE  bs.`borrower_id`=b.`borrowers_id` AND b.`accessionNumber`=i.`accessionNumber`  AND `status`  = 'Due'"
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub searchAllPenalties(ByVal dtg As DataGridView, ByVal txt As TextBox)
        sql = "SELECT distinct(`borrow_id`), CONCAT (`fname`,' ', `lname`,' ', `mname`) as 'Full Name' " _
        & ",`yr` AS 'Year',i.`accessionNumber`as 'Accession Number',`item_title` AS 'TitleOfBooks', `item_author` AS 'Author',`dateBorrow` as 'DateBorrow'" _
        & " FROM `borrow` b,  `borrowers`  bs,`items` i  " _
        & " WHERE  bs.`borrower_id`=b.`borrowers_id` " _
        & " AND b.`accessionNumber`=i.`accessionNumber`  AND `status`  = 'Due'" _
        & " AND (i.`accessionNumber` LIKE '%" & txt.Text & "%' " _
        & " OR item_title  LIKE '%" & txt.Text & "%' " _
        & " OR item_author  LIKE '%" & txt.Text & "%' " _
        & " OR fname  LIKE '%" & txt.Text & "%' " _
        & " OR lname  LIKE '%" & txt.Text & "%') "
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
    Public Sub searchPenaltiesdate(ByVal dtg As DataGridView, ByVal strdate As Object, ByVal enddate As Object)
        sql = "SELECT distinct(`borrow_id`), CONCAT (`fname`,' ', `lname`,' ', `mname`) as 'Full Name' " _
        & ",`yr` AS 'Year',i.`accessionNumber`as 'Accession Number',`item_title` AS 'TitleOfBooks', " _
        & " `item_author` AS 'Author',`dateBorrow` as 'DateBorrow'" _
        & " FROM `borrow` b,  `borrowers`  bs,`items` i  " _
        & " WHERE  bs.`borrower_id`=b.`borrowers_id` " _
        & " AND b.`accessionNumber`=i.`accessionNumber`  AND `status`  = 'Due'" _
        & " AND date(dateBorrow) BETWEEN '" & strdate.text & "' and '" & enddate.text & "'"
        fillGrid(sql, dtg)
        dtg.Columns(0).Visible = False
    End Sub
End Module
